*******************************************************************************
* Filename: eql49###.s
* Author: James D. Purdy
* Description: eql49 equation library browser
* Revision: release 2.6
* Revision date: 1/21/2000
* Stack diagram:
*       ( --> )
*******************************************************************************
INCLUDE Header.h

DEFINE USERFLAG # 5   ( flag for standalone mode )

RPL
EXTERNAL Choose

::
::
RECLAIMDISP ClrDA1IsStat CLEARMENU
#0 "Loading..." $>GROB  Grob>Menu
{ "Equation Library v2.6" }   ( Build  library list )
USERFLAG TestUserFlag NOT IT :: 1009 1 #>ROMPTR EVAL  >TCOMP ;
' ID USEREQ SAFE@_HERE IT >TCOMP

' TRUE
' NULL$
' TRUE
' NULL$
' NULL{}

' ::   ( build menu subr )
  CLEARMENU
  EIGHT TWENTYONE MAKEGROB
  DUP 0 SWAP Grob>Menu
  22 SWAP Grob>Menu
  44 "INFO" MakeInvLabel Grob>Menu
  66 "RCL" MakeInvLabel Grob>Menu
  88 "MSLV" MakeInvLabel Grob>Menu
  110 "SLV" MakeInvLabel Grob>Menu
;

' ::   ( start solver subr )
        2GETLAM
       DUPLENCOMP #1+ ONE DO DUP CARCOMP SWAP CDRCOMP SWAP STRIPTAGS >TCOMP LOOP  ;

' ::  ( get eq from list subr ) 
   2GETLAM 4GETLAM NTHCOMPDROP TOTEMPOB ;

' ::    ( CHOOSER subr -- list, title )

  ' ::
     SIXTY #=casedrop :: TrueTrue ;
     FIVETHREE #=casedrop    ::
        ' ::   NoExitAction
            {
              { "Back" :: TakeOver TRUE DoCKeyCancel ; }
              NullMenuKey
              NullMenuKey
              NullMenuKey
              { "Cancl"  DoCKeyCancel  }
              { "Ok" :: TakeOver 18GETLAM DoCKeyOK ; }
             }  ;
             TRUE ;
     DROPFALSE
   ;
  SWAPROT
  ' :: ( ob decompiler )
        DUPTYPELIST? IT :: ONE NTHCOMPDROP ;
        DUPTYPECSTR? ?SEMI
        DO>STR
   ;
  SWAPONE
  Choose
; ( ___ end of chooser ___ )

' ONE ' ONE          ( pointers )
' NULL{}          ( item list )
' TRUE            ( running )

NULLLAM THIRTEEN NDUP FOURTEEN DOBIND
( 14 eq/info list )
( 13 BIG/LITTLE FLAG )
( 12 TEMP )
( 11 loop var )
( 10 Title  )
( 9 Temporary )
( 8 Menu setup subr )
( 7 striptrags and solver subr )
( 6 get eq sub )
( 5 chooser sub )
( 4 list pointer )
( 3 list size )
( 2 item list )
( 1 Running )

USERFLAG TestUserFlag IT ::
% 9  xTVARS   ( get equations from current directory ) 
  DUPLENCOMP
  #0= NOT ITE 
  ::  DUPLENCOMP #1+ ONE DO DUP CARCOMP SWAP CDRCOMP SWAPDUP SAFE@_HERE DROPSWAP ID>TAG >TCOMP LOOP
       NULL$ 9PUTLAM PATHDIR DUPLENCOMP DUP #1= ITE
         :: 2DROP "Home" # 5C >T$ 9PUTLAM ;
         ::  SWAP CDRCOMP ID Home >HCOMP SWAP
             #1+ ONE DO
                  DUPINDEX@ NTHCOMPDROP ID>$ 9GETLAM
                  SWAP&$ # 5C >T$ 9PUTLAM
                LOOP  DROP ;
         9GETLAM >HCOMP 14GETLAM SWAP >TCOMP 14PUTLAM ;
  :: DROP ;
% 15 xTVARS DUPLENCOMP DUP #0= NOT ITE :: #1+   ( get equations from all subdirectories )
ONE DO DUPINDEX@ NTHCOMPDROP TOTEMPOB
  DUP
  EVAL  % 9  xTVARS 
  DUPLENCOMP
  #0= NOT ITE 
  ::   DUPLENCOMP #1+ ONE DO DUP CARCOMP SWAP CDRCOMP SWAPDUP SAFE@_HERE DROPSWAP ID>TAG >TCOMP LOOP
        SWAP ID>$ # 3C >H$ # 3E >T$  >HCOMP  14GETLAM SWAP
       >TCOMP 14PUTLAM ;
  :: 2DROP ;
  UPDIR  LOOP ;  :: DROP  ;
  DROP
;

14GETLAM DUPLENCOMP #1= ITE DROPTRUE FALSE  ?SEMI

DUP  2PUTLAM  ' ID ^^ ?STO_HERE  NULL{} DUP 9PUTLAM 14PUTLAM    ( drop the list, clear 9,  and free 14 )

BEGIN        ( start of main loop )
1GETLAM
WHILE


BEGIN       ( start of inner/chooser  loop )
  2GETLAM
  DUPTWO NTHCOMPDROP TOTEMPOB                   ( returns first object )
  TYPELIST? ITE ::                              ( which does not have a list )
                  DUPONE NTHCOMPDROP TOTEMPOB   ( in element two )
                  SWAP CDRCOMP SWAP
                  5GETLAM EVAL
                  ITE :: SWAP DUPTYPEBINT?  
                         ITE :: SWAP DUPTYPELIST?
                                ITE :: 2PUTLAM 9GETLAM SWAP >TCOMP 9PUTLAM ;
                                    :: FalseFalse 1PUTLAM ;     ( the "true path out" )
                             ;
                             :: DROP RECLAIMDISP TRUE ?SEMI ;   ( enter pressed, do nothing )
                      ;
                      :: TRUE #=casedrop :: 9GETLAM DUPLENCOMP #1 #>             ( false true back key pressed )
                                            ITE :: INNERCOMP #1- SWAPDROP {}N ;  ( nip off last ob in list )
                                                :: DROP NULL{} ;  9PUTLAM
                                            ' ID ^^ SAFE@_HERE DROP 9GETLAM LENCOMP 2DUP
                                             #0= SWAP #1= OR   
                                             ITE ::  DROP ;
                                                 :: ONE DO  ( move down to last menu )
                                                         9GETLAM INDEX@ NTHCOMPDROP
                                                         #1+ NTHCOMPDROP
                                                        LOOP
                                                 ;  2PUTLAM  ;
                         FALSE #=casedrop ::  RECLAIMDISP ( ' ID ^^ ?PURGE_HERE ) TrueFalse 1PUTLAM ;  ( false false cancel key pressed )
                         RECLAIMDISP ( ' ID ^^ ?PURGE_HERE ) TrueFalse 1PUTLAM                   ( false null? on key pressed )
                      ;
                ;
                :: FalseFalse 1PUTLAM ;
 1GETLAM NOT UNTIL
 ?SEMI
       DUP CARCOMP $>grob 10PUTLAM          ( get title "first obj" and store title as grob )
       CDRCOMP DUPONE NTHCOMPDROP TOTEMPOB  ( file pointer or if user mode, eq's )

       ::   DUPTYPESYMB? casedrop :: { 0 "No Information" } 14PUTLAM ;
            DUPTYPETAG? case :: STRIPTAGS DUPTYPELIST?
                                           ITE  :: 14PUTLAM  CDRCOMP ;
                                                :: DROP { 0 "No Information" } 14PUTLAM ;
                                           ;
           SWAPDROP INCOMPDROP % 1009  SWAP  COERCE2  #>ROMPTR  EVAL
           DUP CARCOMP 14PUTLAM                       ( store info list LAM 10 )
           CDRCOMP                                    ( get the object from the lib )
       ;
       DUPLENCOMP 3PUTLAM 2PUTLAM                    ( calulate EQlist size )
       TRUE 1PUTLAM                                  ( flag the loop )

 8GETLAM EVAL ( build menu )
 " of " 3GETLAM #>$ !append$ "  " !append$ 12PUTLAM  ( build counter string )

 BEGIN
 1GETLAM
 WHILE
     ( start of equation browser loop )
     ZEROZERO 10GETLAM XYGROBDISP    ( display title )
    2GETLAM 4GETLAM  NTHCOMPDROP TOTEMPOB
    13GETLAM ITE  " FPTR 4 1E " " FPTR 4 1F "  DROPSWAPDROP DUPGROBDIM
    DUP 130 #> ITE  ( calculate coodinates to put grob in ctr, if too BIG put at 0,0 )
                 :: DROPZERO 52 ROT #-#2/ ROT XYGROBDISP ;
                 :: 130 SWAP #-#2/ 52  ROT #-#2/ ROT XYGROBDISP ;
    ZERO 4GETLAM #>$ 12GETLAM !append$ $>grob  Grob>Menu ( display # of # )

    WaitForKey  kpNoShift #=casedrop  ::   ( keyboard loop )
         kcOn #=casedrop :: RECLAIMDISP ' ID ^^ ?PURGE_HERE RDROP 3RDROP ;
         kcEnter #=casedrop :: 6GETLAM EVAL STRIPTAGS ;
         kcMODE #=casedrop :: 13GETLAM ITE FALSE TRUE 13PUTLAM
                              ABUFF DUPGROBDIM SWAP ZEROZERO 2SWAP GROB!ZERODRP ;
         kcBackspace #=casedrop ::
            CLEARMENU ZERO "Loading..." $>GROB  Grob>Menu
            ' ID ^^ SAFE@_HERE DROP
           9GETLAM LENCOMP DUP
           #1= ITE :: DROP ;
                   :: ONE DO 9GETLAM INDEX@ NTHCOMPDROP #1+ NTHCOMPDROP  LOOP ;
           2PUTLAM 9GETLAM  INNERCOMP #1- SWAPDROP  ( remove last value from list )
           {}N 9PUTLAM ONE 4PUTLAM
           TrueFalse 1PUTLAM ;
         kcUpArrow #=casedrop ::               ( _ move point selector up ____ )
              ABUFF DUPGROBDIM SWAP ZEROZERO 2SWAP GROB!ZERODRP   ( clear grob display )
              4GETLAM  #1+DUP 3GETLAM         ( point to next eq )
              #> ITE
              :: DROPONE 4PUTLAM ;             ( If greater than end .. point to top )
              :: 4PUTLAM ;  ;
        kcDownArrow #=casedrop ::              ( ___ move point selector down ____ )
          ABUFF DUPGROBDIM SWAP ZEROZERO 2SWAP GROB!ZERODRP   ( clear grob display )
          4GETLAM  #1-DUP ONE                 ( point to next eq )
          #< ITE
          :: DROP  3GETLAM 4PUTLAM ;            ( If greater than end .. point to top )
          :: 4PUTLAM ; ;
        kcRightArrow #=casedrop :: [BEGIN] WINDOWRIGHT kcRightArrow REPKEY? NOT_UNTIL ;   ( fast scroller )
        kcLeftArrow #=casedrop :: [BEGIN]  WINDOWLEFT kcLeftArrow REPKEY? NOT_UNTIL ;
        kcMenuKey3 #=casedrop ::  ( info key )
         CLEARMENU CLEARVDISP 10GETLAM ZEROSWAP Grob>Menu   ( clear all and display title in menu area )
         110 "OK" MakeInvLabel Grob>Menu
         14GETLAM DUPLENCOMP ONE #= IT :: INCOMPDROP % 1009 SWAP COERCE2 #>ROMPTR EVAL ;
         DUP CARCOMP DUPTYPEGROB?
         ITE :: DUPGROBDIM 130 SWAP #-#2/ 58 ROT #-#2/ ROT XYGROBDISP  ( center the grob )
                CDRCOMP DUPLENCOMP #1+DUP #10* ABUFF SWAP HEIGHTENGROB
                ONE DO                                 ( display the variable info )
                       DUPINDEX@ NTHCOMPDROP 13GETLAM ITE $>GROB $>grob   ( below grob )
                       ZERO INDEX@ #10* 58 #+ ROT XYGROBDISP
                  LOOP  DROP ;
             :: DROP "No Picture" $>GROB ZEROZERO ROT XYGROBDISP ( else --- no pic )
                 CDRCOMP DUPLENCOMP #1+DUP #10* ABUFF SWAP HEIGHTENGROB
                 ONE DO                                 ( display that info at 0,0 )
                       DUPINDEX@ NTHCOMPDROP 13GETLAM ITE $>GROB $>grob
                       ZERO INDEX@ #10*
                       ROT XYGROBDISP
                 LOOP  DROP ;
         BEGIN
         1GETLAM
         WHILE
         ( information scroller )
            WaitForKey  
               kpNoShift #=casedrop  ::
                    kcRightArrow #=casedrop :: [BEGIN] WINDOWRIGHT kcRightArrow REPKEY? NOT_UNTIL ;
                    kcLeftArrow #=casedrop :: [BEGIN]  WINDOWLEFT  kcLeftArrow REPKEY? NOT_UNTIL ;
                    kcDownArrow #=casedrop :: [BEGIN] WINDOWDOWN  SLOW kcDownArrow REPKEY? NOT_UNTIL ;
                    kcUpArrow  #=casedrop :: [BEGIN] WINDOWUP SLOW kcUpArrow REPKEY? NOT_UNTIL ;
                    kcMenuKey6 #=casedrop :: FALSE 1PUTLAM ;
                    DROP ;
              kpRightShift #=casedrop ::
                    kcDownArrow #=casedrop :: JUMPBOT  ;
                    kcUpArrow  #=casedrop ::  JUMPTOP ;
                    DROP ;
             2DROP      
             REPEAT
        TRUE 1PUTLAM  RECLAIMDISP
        8GETLAM EVAL ;  ( end of info scroller -- rebuild menu )
        kcMenuKey4 #=casedrop ::   ( rcl key )
          6GETLAM EVAL STRIPTAGS RECLAIMDISP
          FalseFalse 1PUTLAM ;
        kcMenuKey5 #=casedrop ::   ( msolve key )
          7GETLAM EVAL DUPLENCOMP #1 #>
                 ITE ::
                     RECLAIMDISP "Starting Solver" FOUR DISPN
                     ' ID EQ  ?STO_HERE " xMINIT xMSOLVR "
                     FalseFalse 1PUTLAM ;
                     :: DROP  ; ;
        kcMenuKey6 #=casedrop ::   ( solve key )
         RECLAIMDISP "Starting Solver" FOUR DISPN
         7GETLAM EVAL
         ' ID EQ ?STO_HERE DoSolvrMenu
          FalseFalse 1PUTLAM ;
        kcSto #=casedrop ::         ( sto key )
          6GETLAM EVAL STRIPTAGS RECLAIMDISP
          ' ID EQ ?STO_HERE FalseFalse 1PUTLAM ;
        kcEQW  #=casedrop ::         ( eqw key )
          6GETLAM EVAL STRIPTAGS RECLAIMDISP
          AlgObEdit FalseFalse 1PUTLAM  ;
        DROP ( disregard any other keys )
    ;
    kpLeftShift #=casedrop ::
         kcMenuKey5 #=casedrop ::   ( user msolve key )
          7GETLAM EVAL  RECLAIMDISP CLEARMENU
         ' ID ^^ PURGE   FALSE SWAP FALSE 1PUTLAM
         ' ID EQ  ?STO_HERE
         ' ID USOLVR @ IT  EVAL ;
        kcMenuKey6 #=casedrop ::   ( user solve key )        
         6GETLAM EVAL STRIPTAGS RECLAIMDISP CLEARMENU
         ' ID ^^ PURGE  FALSE SWAP FALSE 1PUTLAM
         ' ID EQ  ?STO_HERE
         ' ID USOLVR @ IT EVAL ;
        DROP
    ;
    kpRightShift     #=casedrop :: DROP ;
    kpANoShift       #=casedrop :: DROP ;
    kpALeftShft      #=casedrop :: DROP ;
    kpARightShft     #=casedrop :: DROP ;
    kpARightShift    #=casedrop :: DROP ;
    kpALeftShift     #=casedrop :: DROP ;
   
 REPEAT  ( return to loop inner loop )
 ITE TRUE FALSE 1PUTLAM
  RECLAIMDISP
REPEAT ( outer loop )
;
 ' ID ^^ ?PURGE_HERE
;


